### 1.Linux根文件系统  

![image-20240429174454787](C:\Users\dd\AppData\Roaming\Typora\typora-user-images\image-20240429174454787.png)

- /bin      
    是binary的缩写，这个目录存放着最经常使用的命令，通过上方桌面可以看到bin文件夹有个箭头，是链接到 /usr/bin下，相当于快捷方式，进入/bin和/usr/bin下是一模一样的。  
    
- /sbin       
    s就是super User的意思，这里存放的是系统管理员使用的系统管理程序。       
    
- /home     
    存放普通用户的主目录，在Linux中每个用户都有一个自己的目录，一版该目录名是以用户的账号命名的。  
    
- /root     
    该目录为系统管理员，也称为超级权限者的用户主目录。      
    
- /lib  
    系统开机所需要最基本的动态连接共享库，其作用类似于windows里的DLL文件。几乎所有的应用程序都需要用到这些共享库。  
    
- /etc  
    所有的系统管理所需要的配置文件和子目录。  
    
- /usr  
    这是一个非常重要的目录，用户的很多应用程序和文件都放在这个目录下，类似于windows下的program fies目录。  
    
- /boot  
    这里存放的是启动linux时使用的一些核心文件，包括一些连接文件以及镜像文件，自己的安装别放这里。
    
- /proc  
    这个目录是一个虚拟目录，它是系统内存的映射，我们可以通过直接访问这个目录来获取系统信息。
    
- /srv  
    service缩写，该目录存放一些服务启动之后需要提取的数据。
    
- /sys   
    这是linux2.6内核的一个很大的变化。该目录下安装了2.6内核中新出现的一个文件系统sysfs。
    
- /tmp   
    这个目录是用来存放一些临时文件的。  
    
- /dev  
    类似于windows的设备管理器，把所有的硬件用文件的形式存储。管理着所有设备，例如CPU、硬盘等等。
    
- /media  
	linux系统会自动识别一些设备，例如U盘、光驱等等，当识别后，linux会把识别的设备挂载到这个目录下。	
	
- /mnt  
	系统提供该目录是为了让用户临时挂载别的文件系统的，我们可以将外部的存储挂载在/mnt上，然后进入该目录就可以查看里面的内容了。和media差不多  
	
- /opt  
	这是给主机额外安装软件所摆放的目录。比如你安装一个mysql数据库则就可以放在这个目录下。默认是空的。
	
- /var  
	这个目录中存放着在不断扩充的东西，我们习惯将那些经常被修改的目录放在这个目录下。包括各种日志文件。
	
- /lost+found
	这个目录一般情况下是空的，当系统非法关机后，这里就存放了一些文件。
	
- /www
	/www目录可以用于存储Web应用程序或网站文件，/www目录没有特别的用途，它只是一个常规目录，可以根据需要进行使用和管理。

### <font color = "red">2.常用命令</font>  

#### 2.1 文件目录类

- pwd 显示当前工作目录的绝对路径

-  ls 列出目录的内容

-  cd 切换目录

-  mkdir 创建一个新的目录 、 rmdir 删除一个空的目录

-  touch 创建空文件

-  cp 复制文件或目录

-  rm 删除文件或目录

-  mv 移动文件与目录或重命名

-  cat 查看文件内容

- more 文件内容分屏查看器

-  less 分屏显示文件内容

-  echo输出内容到控制台

- tail 输出文件尾部内容

-  输出重定向 和 >> 追加

-  ln 软链接

-  history 查看已经执行过历史命令

- 时间日期类

#### 2.2 用户管理命令

- useradd 添加新用户

- passwd 设置用户密码

- id 查看用户是否存在

- cat /etc/passwd 查看创建了哪些用户

- su 切换用户

- userdel 删除用户

- sudo 设置普通用户具有 root 权限

- usermod 修改用户

- groupadd 新增组

- groupdel 删除组

- groupmod 修改组

- cat /etc/group 查看创建了哪些组

#### 2.3 文件权限命令

- 使用`ll`或 `ls -lh`命令查看权限

- rwx 作用文件和目录的不同解释

-  chmod 改变权限
#### 2.4  搜索查找命令

-  find 查找文件或者目录

-  locate 快速定位文件路径

-  grep 过滤查找及 | 管道符
#### 2.5  压缩和解压命令

-  gzip/gunzip 压缩

-  zip/unzip 压缩

-  tar 打包
#### 2.6 磁盘查看和分区命令

-  du 查看文件和目录占用的磁盘空间

-  df 查看磁盘空间使用情况

-  lsblk 查看设备挂载情况

-  mount/umount 挂载/卸载

-  fdisk分区
#### 2.7 进程管理命令

-  ps 查看当前系统进程状态

-  kill 终止进程

-  pstree 查看进程树

-  top 实时监控系统进程状态

-  netstat显示网络状态和端口占用信息

-  crontab 定时任务设置

  







